import "package:geiger_dummy_data/geiger_dummy_data.dart";
import 'package:geiger_localstorage/geiger_localstorage.dart';

void main() {
  //initialize database
  StorageController _storageController =
      GenericController("Example", SqliteMapper("./example.db"));

  //set and get threat
  ThreatNode _geigerThreat = ThreatNode(_storageController);
  //set and get current user
  UserNode _geigerUser = UserNode(_storageController);
  //set and get current device
  DeviceNode _geigerDevice = DeviceNode(_storageController);

  //store and retrieve threats from :Global:threats
  // return a List of Threat object containing threatId and name.
  List<Threat> getThreatInfo() {
    try {
      return _geigerThreat.getThreats();
    } catch (e) {
      // threatId is optional: is auto generated.
      List<Threat> threatData = [
        Threat(name: "phishing"),
        Threat(name: "Malware")
      ];

      //store threat in :Global:threats:
      _geigerThreat.setGlobalThreatsNode(threats: threatData);

      return _geigerThreat.getThreats();
    }
  }

  //store and retrieve currentUserInfo from :Local "currentUser" NodeValue
  User? getCurrentUser() {
    try {
      return _geigerUser.getUserInfo;
    } catch (e) {
      //set current user info
      User userData =
          User(termsAndConditions: TermsAndConditions(), consent: Consent());

      //store current user info
      _geigerUser.setUserInfo = userData;
      return _geigerUser.getUserInfo;
    }
  }

  //store  and retrieve currentDeviceInfo from :Local "currentDeviceNew NodeValue
  Device? getCurrentDevice() {
    try {
      return _geigerDevice.getDeviceInfo;
    } catch (e) {
      //set current device info
      // format
      Device deviceData = Device(owner: getCurrentUser()!);

      //store current user info
      _geigerDevice.setCurrentDeviceInfo = deviceData;
      return _geigerDevice.getDeviceInfo;
    }
  }

  // display terminal threat info
  print("Threats: ${getThreatInfo()}");

  // display current user info in terminal
  print("Current User: ${getCurrentUser()}");

  //display current device info in terminal
  print("Current Device: ${getCurrentDevice()}");
}
